
/* ESP-now  Property Bell - Receiver ESP8266 with buzzer
 * Markus Opitz, August 2022 
 * https://www.instructables.com/Property-Bell/
 */


#if defined(ESP8266)
  #include <ESP8266WiFi.h>
#elif defined(ESP32)
  #include <WiFi.h>
#endif

//buzzer
int piezoPin = 12;

#include <espnow.h>
// Structure example to receive data
// Must match the sender structure
typedef struct struct_message {
    char a[32];
    int b;

} struct_message;

// Create a struct_message called myData
struct_message myData;


// Callback function that will be executed when data is received   -  -  -  -  -  -  -  -  -  -  -
void OnDataRecv(uint8_t * mac, uint8_t *incomingData, uint8_t len) {
  memcpy(&myData, incomingData, sizeof(myData));
  Serial.print("Bytes received: ");
  Serial.println(len);
  Serial.print("Char: ");
  Serial.println(myData.a);
  Serial.print("Int: ");
  Serial.println(myData.b);
}


void setup() {  // -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -

  Serial.begin(115200);

   // Set device as a Wi-Fi Station
  WiFi.mode(WIFI_STA);

  // Init ESP-NOW
  if (esp_now_init() != 0) {
    Serial.println("Error initializing ESP-NOW");
    return;
  }
  
  // Once ESPNow is successfully Init, we will register for recv CB to
  // get recv packer info
  esp_now_set_self_role(ESP_NOW_ROLE_SLAVE);
  esp_now_register_recv_cb(OnDataRecv);

}

void loop() {  // -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  dingdong();
}



void dingdong() { // -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  -  
  if (myData.b == 4376){       //number must match with 'Bell-Transmitter.ino'
    tone(piezoPin, 440, 300);
    delay(300);
    tone(piezoPin, 350, 600);
    delay(1000);
    myData.b = 0; // reset
  }
}
